<?php
    function idehnic_getConfigArray()
    {
        $configarray = [
            'webtoken' => [
                'Type' => 'text', 'Size' => '300', 'Description' => 'token یا همان گذرواژه اتصال را وارد نمایید',
            ],
        ];

        return $configarray;
    }

    function idehnic_RegisterDomain($params)
    {
        return run_query('register', [
            CURLOPT_POSTFIELDS => json_encode([
                'data' => [
                    'domain' => $params['sld'],
                    'tld' => $params['tld'],
                    'period' => (int) $params['regperiod'],
                    'contacts' => [
                        'holder' => $params['additionalfields']['NIC Handle'],
                        'admin' => '',
                        'tech' => '',
                        'bill' => ''
                    ],
                    'nameservers' => [
                        'ns1' => !empty($params['ns1']) ? $params['ns1'] : '',
                        'ip1' => '',
                        'ns2' => !empty($params['ns2']) ? $params['ns2'] : '',
                        'ip2' => ''
                    ]
                ]
            ])], $params);
    }

    function idehnic_RenewDomain($params)
    {
        return run_query('renew', [
            CURLOPT_POSTFIELDS => json_encode([
                'data' => [
                    'domain' => $params['sld'],
                    'tld' => $params['tld'],
                    'period' => (int) $params['regperiod']
                ]
            ])], $params);
    }

    function idehnic_SaveNameservers($params)
    {
        return run_query('ns/assign', [
            CURLOPT_POSTFIELDS => json_encode([
                'data' => [
                    'domain' => $params['sld'],
                    'tld' => $params['tld'],
                    'nameservers' => [
                        'ns1' => !empty($params['ns1']) ? $params['ns1'] : '',
                        'ip1' => !empty($params['ip1']) ? $params['ip1'] : '',
                        'ns2' => !empty($params['ns2']) ? $params['ns2'] : '',
                        'ip2' => !empty($params['ip2']) ? $params['ip2'] : '',
                        'ns3' => !empty($params['ns3']) ? $params['ns3'] : '',
                        'ip3' => !empty($params['ip3']) ? $params['ip3'] : '',
                        'ns4' => !empty($params['ns4']) ? $params['ns4'] : '',
                        'ip4' => !empty($params['ip4']) ? $params['ip4'] : '',
                    ]
                ]
        ])], $params);
    }

    function idehnic_Sync($params)
    {
        return run_query('domain/sync', [
            CURLOPT_POSTFIELDS => json_encode([
                'data' => [
                    'domain' => $params['sld'],
                    'tld' => $params['tld'],
                ]
        ])], $params);
    }

    function idehnic_GetNameservers($params)
    {
        return run_query('ns/info', [CURLOPT_POSTFIELDS => json_encode([
            'data' => [
                'domain' => $params['sld'],
                'tld' => $params['tld'],
            ]
        ])], $params);
    }

    // Run request..
    function run_query(string $operation, array $options_mod = [], array $params = [])
    {
        $curl = curl_init();
        $options = array(
            CURLOPT_URL => 'https://idehnic.ir/api/v1/domains/'. $operation,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => json_encode([
                'data' => [
                    "domain" => $params['sld'],
                    "tld" => $params['tld']
                ]
            ]),
            CURLOPT_HTTPHEADER => array(
                'Authorization: Bearer ' . $params['webtoken'],
                'Content-Type: application/json'
            ),
        );

        foreach (array_keys($options) as $key)
            if (isset($options_mod[$key]))
                $options[$key] = $options_mod[$key];

        curl_setopt_array($curl, $options);
        $response = curl_exec($curl);

        curl_close($curl);
        return json_decode($response, false);
    }
